﻿using System;
using System.Collections.Generic;
using System.Drawing;
using System.Linq;
using System.Text;
using Infragistics.Win;
using Infragistics.Win.UltraWinSchedule;
using Infragistics.Win.UltraWinSchedule.DayView;

namespace _138118
{
    class Mycreation:IUIElementCreationFilter
    {
        public delegate void OnOwnerHeaderCheck(object sender, OwnerHeaderCheckBoxArg e);
        public event OnOwnerHeaderCheck OwnerHeaderCheck;

        Dictionary<Owner, bool> ownerState = new Dictionary<Owner, bool>();
        #region IUIElementCreationFilter Members

        public void AfterCreateChildElements(UIElement parent)
        {
            if (parent is OwnerHeaderUIElement)
            {
                OwnerHeaderUIElement owner = parent as OwnerHeaderUIElement;
                if (!ownerState.ContainsKey(owner.Owner))
                    ownerState.Add(owner.Owner, false);
                CheckBoxUIElement chek = new CheckBoxUIElement(parent);
                Point loc = parent.Rect.Location;
                loc.Offset(parent.Rect.Width - 50, 2);
                chek.Rect = new System.Drawing.Rectangle(loc, new Size(50, parent.Rect.Height - 4));
                chek.Text = "Draft";
                chek.CheckState = ownerState[owner.Owner] ? System.Windows.Forms.CheckState.Checked : System.Windows.Forms.CheckState.Unchecked;
                chek.ElementClick += chek_ElementClick;
                parent.ChildElements.Add(chek);
            }
        }

        void chek_ElementClick(object sender, UIElementEventArgs e)
        {
            CheckBoxUIElement c = (CheckBoxUIElement)e.Element;
            OwnerHeaderUIElement parent = (OwnerHeaderUIElement)e.Element.Parent;

            ownerState[parent.Owner] =  c.CheckState == System.Windows.Forms.CheckState.Checked   ? true : false;
            if (OwnerHeaderCheck != null)
                OwnerHeaderCheck.Invoke(sender, new OwnerHeaderCheckBoxArg(parent.Owner));
           
        }

        public bool BeforeCreateChildElements(UIElement parent)
        {
            return false;
        }

        #endregion
    }

    public class OwnerHeaderCheckBoxArg : EventArgs
    {
        Owner o;
        public Owner Owner
        {
            get { return o; }
        }

        public OwnerHeaderCheckBoxArg(Owner owner)
        {
            this.o = owner;
        }
    }
}
